#!/System/Library/Frameworks/Ruby.framework/Versions/Current/usr/bin/ruby
# encoding: utf-8
path = File.expand_path('.')
ruby_version = '2.4.0'
$:.unshift "#{path}/"
$:.unshift "#{path}/ruby/#{ruby_version}/extensions/x86_64-darwin-16/2.4.0/nokogiri-1.5.11"
$:.unshift "#{path}/ruby/#{ruby_version}/gems/nokogiri-1.5.11/lib"
$:.unshift "#{path}/ruby/#{ruby_version}/gems/reverse_markdown-1.0.3/lib"

require 'nokogiri'
require 'reverse_markdown'
require 'shellwords'
require 'fileutils'
require 'cgi'
require 'rexml/document'

class String
  def double_indent
    input = self.dup
    self.gsub(/  /,'    ')
  end

  def markdownify
        input = self.dup
        input.sub!(/(?:.|\n)*?<body>((?:.|\n)*)<\/body>(?:.|\n)*/, '\1')
        input.gsub!(/<span class="Apple-tab-span">.*?<\/span>/,' ')
        input.gsub!(/<span class="s2">.*?<\/span>/,'')
        input.gsub!(/•/,'')
        input.gsub!(/(?mi)&lt;\$Scr_H::1&gt;/,'<h2>')
        input.gsub!(/(?mi)&lt;!\$Scr_H::1&gt;/,'</h2>')
        input.gsub!(/&lt;!?\$Scr_Ps::0&gt;/,'')
        input.gsub!(/&lt;!?\$Scr_Cs::\d&gt;/,'')
        input.gsub!(/[“”]/,'"')
        input.gsub!(/[’‘]/,"'")
        input.gsub!(/<\/?span.*?>/, '')
        # input.gsub!(/&gt;/, '>')
        # input.gsub!(/&lt;/, '<')
        input.gsub!(/&amp;/, '&')
        input.gsub!(/&nbsp;/, ' ')
        input.gsub!(/<table .*?class=".*?">(.*?)<\/table>/m) {|m|
          m.gsub!(/\s*<\/?t.*?>/,'')
          # puts '<blockquote class="mkscrivtable">' + m.markdownify + '</blockquote>'
          "\n$@$@$@$@\n" + m + "\n!@!@!@!@\n"

        }
        result = ReverseMarkdown.convert(input).to_s
        result.gsub!(/(?mi)(#+) \*\*(.*?)\*\*/,'\1 \2')
        result.gsub!(/(?mi)^(#+.*?\n)(?=\S)/,"\\1\n")
        result.gsub!(/(?mi)^(>+[\s\S]*(?=\n\n))/,"\n\\1\n")
        result.gsub!(/(?mi)^ +(?=[-*+])/) {|m|
          m.double_indent
        }
        result.gsub!(/\\([*_><])/,'\1')
        result.gsub!(/(?mi)^\$@\$@\$@\$@(.*?)!@!@!@!@$/) {|m|
                match = Regexp.last_match
                "> " + match[1].strip.split(/\n/).join("\n> ")
              }
        result.gsub!(/(?mi) ?\(\(\(\(COMMENT\)\)\)\)(.*?)\(\(\(\(\/COMMENT\)\)\)\) ?/,'<span class="mkscriv_annotation">\1</span>')
        return result.to_s
      end
end

input =<<EOI
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <title></title>
  <meta name="Generator" content="Cocoa HTML Writer">
  <meta name="CocoaVersion" content="1561">
  <style type="text/css">
    p.p1 {margin: 0.0px 0.0px 0.0px 0.0px; font: 16.0px 'Meslo LG S DZ'; color: #343434}
    p.p2 {margin: 0.0px 0.0px 0.0px 0.0px; font: 16.0px 'Meslo LG S DZ'; min-height: 22.0px}
    p.p3 {margin: 0.0px 0.0px 0.0px 0.0px; font: 16.0px 'Meslo LG S DZ'; color: #343434; min-height: 22.0px}
  </style>
</head>
<body>
<p class="p1">There are a few areas where tagging can be truly beneficial to those who develop and maintain a consistent system. We'll talk a bit about how to develop those systems shortly, but let's take a broad overview of the usefulness of tagging.</p>
<p class="p2"><br></p>
<p class="p1">{&gt;&gt;Just testing something&lt;&lt;}We've long been constrained to using file naming conventions and folder structures to organize our files in a way that gives us any hope of finding them again a year in the future. Tagging doesn't hinder any of these existing systems, but rather augments them and reduces our reliance on them for more abstract organization.</p>
<p class="p3"><br></p>
<p class="p1">You can now have a file "exist" in multiple locations without needing a physical copy of it. You can separate larger folders of files with realistic relationships without needing to nest a dozen folders within it.</p>
<p class="p3"><br></p>
<p class="p1">You can also organize by concepts, events and other relationships that might not be suited to a folder system where those files already need to exist as part of a specific project or collection. If you collect photos for creative projects, for example, you can now sort those photos into folders related to their individual project, but tag them with general terms and be able to see all of your "inspiration" and "flat design" photos at once, regardless of the project folder <a href="scrivcmt://1C047C26-45E0-4F19-BF88-6548FB958F63">they're located in</a>.</p>
<p class="p2"><br></p>
<p class="p1">Navigating through a folder system takes time. Spotlight can help by showing you just the PDF files inside of the current folder, for example, but you still need to search by filename or contents to track down the specific file you need.</p>
<p class="p3"><br></p>
<p class="p1">Tagging allows a simple, system-wide search to turn up exactly the file you're looking for with a one-line search and no digging.<span class="Apple-converted-space"> </span></p>
<p class="p3"><br></p>
<p class="p2"><br></p>
<p class="p1"><a href="scrivcmt://A8073903-7DC6-4979-8779-16BABFE49233">The benefits of unconditional associations between files</a></p>
</body>
</html>
EOI


puts input.markdownify
